/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Fri Feb 22 02:16:12 2002 by Jeff Dalton
 * Copyright: (c) 2001 - 2002, AIAI, University of Edinburgh
 */

package ix.icore;

import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;

import ix.util.*;
import ix.util.lisp.*;

/**
 * An Activity.
 */

public class Activity extends TaskItem {

    public Activity() { }	// for XML translator /\/

    public Activity(String text) {
	this(Lisp.elementsFromString(text));
    }

    public Activity(LList pattern) {
	super(pattern);
    }

    public Name generateId() {
	return Name.valueOf(Util.generateName("activity"));
    }

    public String toString() {
	return "Activity[id=" + id  + " " + Lisp.elementsToString(pattern)
	    + "]";
    }

}
