/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Sun Jun  2 00:12:50 2002 by Jeff Dalton
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 */

package ix.iface.domain;

import java.io.*;
import java.util.*;

import ix.icore.domain.*;
import ix.util.*;
import ix.util.xml.*;

// Imports for using JDOM
// import java.io.IOException;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;


/**
 * A writer for domains described in our standard XML syntax.
 */
public class XMLTF_Writer extends DomainWriter {

    File domainName;

    public XMLTF_Writer(File domainName) {
	this.domainName = domainName;
    }

    //
    // Writing a domain description using JDOM
    //

    public void writeDomain(Domain domain) 
    throws IOException {
	Document domainDoc = makeDomainDocument(domain);
	// Get a stream to write to
	OutputStream out = 
	    new BufferedOutputStream(
                new FileOutputStream(domainName));
	// Create an outputter with 3 space indent and newlines=true
	XMLOutputter outputter = new XMLOutputter("  ", true);
	outputter.setLineSeparator(System.getProperty("line.separator"));
	// outputter.setTrimText(true); // deprecated in beta-7 & wrong anyway
	outputter.setTextNormalize(false);
	outputter.output(domainDoc, out);
	out.flush();
    }

    /** Converts the domain to a JDOM Document. */
    public Document makeDomainDocument(Domain domain) {
	return XML.objectToDocument(domain);
    }

}
