/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Sun Dec  2 03:59:16 2001 by Jeff Dalton
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 */

package ix.iface.util;

import javax.swing.plaf.ColorUIResource;

import javax.swing.plaf.metal.DefaultMetalTheme;

import ix.util.Parameters;

/**
 * A Metal theme for I-X applications. <p>
 *
 * Use like this:
 * <pre>
 *   MetalLookAndFeel.setCurrentTheme(new IXMetalTheme());
 * </pre>
 */
public class IXMetalTheme extends DefaultMetalTheme {

    public String getName() {
	return "IXMetalTheme";
    }

    private int secondary3_value =
	Parameters.getInt("metal-theme-secondary3", 0xCCCCCC);

    // private ColorUIResource secondary3 = new ColorUIResource(0xd1d1df);
    private ColorUIResource secondary3
	= new ColorUIResource(secondary3_value);

    protected ColorUIResource getSecondary3() {
	return secondary3;
    }

}
