/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Fri Feb 22 14:23:40 2002 by Jeff Dalton
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 */

package ix.itest;

import javax.swing.*;

import ix.util.xml.XML;		// for debugging output
import ix.iface.util.Reporting;

import ix.util.*;


/**
 * I-TEST panel for displaying received messages.
 */
public class ReceivePanel extends JPanel {

    Itest itest;

    JTextArea receiveText = new JTextArea(15, 40);

    public ReceivePanel(Itest itest) {
	this.itest = itest;
	setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	setBorder(BorderFactory.createTitledBorder("Received"));

	receiveText.setEditable(false);
	add(new JScrollPane(receiveText));
    }


    /**
     * Handles external input in the form of an IPC.InputMessage
     * that contains an Issue or Report object.
     */
    public void handleInput(IPC.InputMessage message) {
	appendLine(Reporting.messageDescription(message));
    }

    public void appendLine(String text) {
	String lineSeparator = System.getProperty("line.separator");
	append(text + lineSeparator);
    }

    public void append(String text) {
	receiveText.append(text);
	// Setting caret position to end should scoll to the end
	receiveText.setCaretPosition(receiveText.getText().length());
    }

}

