/****************************************************************************
 * A node renderer for list or table cells that displays "[number] elements".
 *
 * @author Jussi Stader
 * @version 1.0
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 *
 *****************************************************************************
 */
package ix.iview;

import java.util.Iterator;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.ListCellRenderer;

import ix.util.Name;
import ix.util.lisp.LList;
import ix.iface.ui.IXRenderer;
import ix.icore.domain.NodeSpec;

/****************************************************************************
 * A node renderer for list or table cells that displays "[number] elements".
 *****************************************************************************
 */
class FullNodeRenderer extends IXRenderer {
  /** 
   * Creates a node name renderer with/without a border.
   * @param isBordered - flag that determines whether to put a border around
   * the cell to show selection status
   */
  public FullNodeRenderer(boolean isBordered) {super(isBordered);}
  /**
   * Sets the cell text to the node number and name e.g. "[2] alter plan"
   */
  protected void setInfo(Object object){
    if (object == null) setText("");
    else {
      NodeSpec node = (NodeSpec)object;
      Name name = node.getId();
      LList pattern = node.getPattern();;
      String text = "";
      for (Iterator i = pattern.iterator(); i.hasNext();) {
	  text = text + i.next().toString() + " ";
      }
      text = "[" + name.toString() + "] " + text;
      setText(text);
    }
  }
}
