/****************************************************************************
 * A simple node name renderer for list or table cells.
 *
 * @author Jussi Stader
 * @version 2.0
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 *
 *****************************************************************************
 */
package ix.iview;

import java.util.Iterator;
import java.util.List;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.ListCellRenderer;

import ix.util.Name;
import ix.util.lisp.*;
import ix.iface.ui.IXRenderer;
import ix.icore.domain.NodeSpec;

/****************************************************************************
 * A simple node name renderer for list or table cells.
 *****************************************************************************
 */
class NodeNameRenderer extends IXRenderer {
  /** 
   * Creates a node name renderer with/without a border.
   * @param isBordered - flag that determines whether to put a border around
   * the cell to show selection status
   */
  public NodeNameRenderer(boolean isBordered) {super(isBordered);}
  /**
   * Sets the cell text to the node name e.g. "alter plan"
   */
  protected void setInfo(Object object){
    if (object == null) setText("");
    else {
      List pattern = Lisp.NIL;
      if (LList.class.isAssignableFrom(object.getClass())) {
	LList list = (LList)object;
	pattern = (LList)list.elementAt(1);
      }
      else if (NodeSpec.class.isAssignableFrom(object.getClass()))
	pattern = ((NodeSpec)object).getPattern();
      String text = "";
      for (Iterator i = pattern.iterator(); i.hasNext();) {
	text = text + i.next().toString() + " ";
      }
      setText(text);
    }
  }

}

