/****************************************************************************
 * A simple node number renderer for list or table cells.
 *
 * @author Jussi Stader
 * @version 2.0
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 *
 *****************************************************************************
 */
package ix.iview;

import java.awt.Color;
import java.awt.Component;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.ListCellRenderer;

import ix.util.Name;
import ix.util.lisp.LList;
import ix.iface.ui.IXRenderer;
import ix.icore.domain.NodeSpec;
import ix.icore.domain.Named;
import ix.iview.domain.UIRefinement;

/****************************************************************************
 * A simple node number renderer for list or table cells.
 *
 *****************************************************************************
 */
class NodeNumberRenderer extends IXRenderer {
  /** 
   * Creates a node number renderer with/without a border.
   * @param isBordered - flag that determines whether to put a border around
   * the cell to show selection status
   */
  public NodeNumberRenderer(boolean isBordered) {super(isBordered);}
  /**
   * Sets the cell text to the node number.
   */
  protected void setInfo(Object object){
    if (object == null) setText("");
    else {
      String text = "??";
      java.lang.Class theClass = object.getClass();
      if (LList.class.isAssignableFrom(theClass)) 
	text = (((LList)object).elementAt(0).toString());
      else if (NodeSpec.class.isAssignableFrom(theClass)) 
	text = ((NodeSpec)object).getId().toString();
      else if (UIRefinement.class.isAssignableFrom(theClass)) 
	text = "self (" + ((Named)object).getName() + ")";
      setText(text);
    }
  }
}
