/* File: IVUtil.java
 * Contains: A class for useful static methods for IViews
 * Author: Jussi Stader <J.Stader@ed.ac.uk>
 * Created: April 2002
 * Copyright: (c) 2002, AIAI, University of Edinburgh
 */

package ix.iview.util;

import ix.iface.ui.util.*;
import ix.icore.domain.*;
import ix.iview.domain.*;
import ix.util.*;
import ix.util.lisp.*;
import java.lang.reflect.*;
import java.util.*;
import java.net.URL;
import javax.swing.*;
import java.awt.Component;
import java.awt.event.*;


/** Class for useful static methods. */

public class IVUtil {
  public static String namedListToDisplay(Collection l) {
    String text = "";
    Iterator i = l.iterator();
    while (i.hasNext()) 
      text = text + ((Named)i.next()).getName() + " ";
    return text;
  }

  public static Collection sortNamedCollection(Collection c) {
    Map sortMap = new TreeMap();
    Collection empties = new ArrayList(); //collect empty names seperately
    for (Iterator i = c.iterator(); i.hasNext(); ) {
      Named n = (Named)i.next();
      if (n != null) { //ignore null elements
	String name = n.getName();
	if ((name == null) || (name.equals(""))) empties.add(n);
	else sortMap.put(name, n);
      }
    }
    Collection sorted = new ArrayList(sortMap.values()); 
    sorted.addAll(empties);
    return sorted;
  }

  //--------------------------- UIObject things

  /**
   * Check if the object should be overwritten or copied. Ask the user if 
   * copying makes sense.
   */
  public static boolean checkCopyObject(String thing, UIObject uio, 
					String name) {
    if ((uio == null) || uio.isEmpty()) return false;
    else {
      String oldName = uio.getName();
      //Debug.noteln("IVU: Old name is", oldName);
      if ((oldName != null) && !oldName.equals("") && 
	  (uio.nameHasChanged(name))) {
	String[] message = {"You have changed the name of the " + thing + ".",
			    "Do you want to overwrite the original",
			    "or define a new one?"};
	Object[] options = { "Overwrite", "New" };
	int y = JOptionPane.showOptionDialog(null, message, "Confirm", 
					     JOptionPane.DEFAULT_OPTION, 
					     JOptionPane.QUESTION_MESSAGE,
					     null, options, options[0]);
	//Debug.noteln("AFoP: chose option", y);
	if (y == 1) return true; //chose "new", so do copy
      }
      return false;
    }
  }


}
