/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Fri Feb  8 14:03:04 2002 by Jeff Dalton
 * Copyright: (c) 2001, AIAI, University of Edinburgh
 */

package ix.util;

import java.io.Serializable;

/**
 * Wrapper for relatively short strings used as names. <p>
 *
 * Names should be created by calling <code>Name.valueOf(String)</code>.
 */
public class Name implements Serializable, SemiPrimitive {

    protected String name;

    protected Name() { }

    protected Name(String name) {
	this.name = name;
    }

    public String toString() {
	return name;
    }

    public static Name valueOf(String name) {
	return new Name(name);
    }

    public static Name valueOf(Object obj) {
	// This method is very convenient but doesn't always
	// make sense.  /\/
	return valueOf(obj.toString());
    }

    public int hashCode() {
	return name.hashCode();		// ??? /\/
    }

    public boolean equals(Object a) {
	return (a instanceof Name) && ((Name)a).name.equals(name);
    }

}

// Issues:
// * Perhaps should be called Id.  Problem is we may want Id for
//   use as an ID in XML.

