/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Thu Mar 14 04:57:07 2002 by Jeff Dalton
 * Copyright: (c) 2002, AIAI, University of Edinburgh
 */

package ix.util.xml;

import java.util.*;

import ix.util.*;


/**
 * A class for translating between objects and XML that uses lower-case
 * names and separates words within names with dashes.
 */

public class DashSyntaxXMLTranslator extends XMLTranslator {

    public DashSyntaxXMLTranslator() {
	super();
    }

    public String internalFieldName(String externalName) {
	return Strings.uncapitalize(internalName(externalName));
    }

    public String internalName(String externalName) {
	return Strings.dashNameToJavaName(externalName);
    }

    public String externalName(String internalName) {
	return Strings.javaNameToDashName(internalName);
    }

    /**
     * Simple main program used for testing.
     */
    public static void main(String[] argv) {
	do_main(new DashSyntaxXMLTranslator());
    }

}
